package xyz.lychee.lagfixer.libs.adventure.builder;

import java.util.function.Consumer;
import xyz.lychee.lagfixer.libs.annotations.Contract;
import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.annotations.Nullable;

@FunctionalInterface
public interface AbstractBuilder<R> {
   @Contract(
      mutates = "param1"
   )
   static <R, B extends AbstractBuilder<R>> @NotNull R configureAndBuild(final @NotNull B builder, final @Nullable Consumer<? super B> consumer) {
      if (consumer != null) {
         consumer.accept(builder);
      }

      return builder.build();
   }

   @Contract(
      value = "-> new",
      pure = true
   )
   @NotNull R build();
}
